# wxTreeCtrl Class Reference
[Controls]

`#include <wx/treectrl.h>`

Inheritance diagram for wxTreeCtrl:
[legend]

## Detailed Description

A tree control presents information as a hierarchy, with items that may be expanded to show further items.

Items in a tree control are referenced by wxTreeItemId handles, which may be tested for validity by calling wxTreeItemId::IsOk().

A similar control with a fully native implementation for GTK+ and OS X as well is wxDataViewTreeCtrl.

To intercept events from a tree control, use the event table macros described in wxTreeEvent.

## Styles

This class supports the following styles:

- wxTR_EDIT_LABELS:
  Use this style if you wish the user to be able to edit labels in the tree control.
- wxTR_NO_BUTTONS:
  For convenience to document that no buttons are to be drawn.
- wxTR_HAS_BUTTONS:
  Use this style to show + and - buttons to the left of parent items.
- wxTR_TWIST_BUTTONS:
  Selects alternative style of `+/`-` buttons` and shows rotating ("twisting") arrows instead. Currently this style is only implemented under Microsoft Windows Vista and later Windows versions and is ignored under the other platforms. Notice that under Vista this style results in the same appearance as used by the tree control in Explorer and other built-in programs and so using it may be preferable to the default style.
- wxTR_NO_LINES:
  Use this style to hide vertical level connectors.
- wxTR_FULL_ROW_HIGHLIGHT:
  Use this style to have the background colour and the selection highlight extend over the entire horizontal row of the tree control window. (This flag is ignored under Windows unless you specify `wxTR_NO_LINES` as well.)
- wxTR_LINES_AT_ROOT:
  Use this style to show lines between root nodes. Only applicable if `wxTR_HIDE_ROOT` is set and `wxTR_NO_LINES` is not set.
- wxTR_HIDE_ROOT:
  Use this style to suppress the display of the root node, effectively causing the first-level nodes to appear as a series of root nodes.
- wxTR_ROW_LINES:
  Use this style to draw a contrasting border between displayed rows.
- wxTR_HAS_VARIABLE_ROW_HEIGHT:
  Use this style to cause row heights to be just big enough to fit the content. If not set, all rows use the largest row height. The default is that this flag is unset. Generic only.
- wxTR_SINGLE:
  For convenience to document that only one item may be selected at a time. Selecting another item causes the current selection, if any, to be deselected. This is the default.
- wxTR_MULTIPLE:
  Use this style to allow a range of items to be selected. If a second range is selected, the current range, if any, is deselected.
- wxTR_DEFAULT_STYLE:
  The set of flags that are closest to the defaults for the native control for a particular toolkit.

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxTreeEvent& event)
Event macros for events emitted by this class:

- EVT_TREE_BEGIN_DRAG(id, func):
  Begin dragging with the left mouse button. If you want to enable left-dragging you need to intercept this event and explicitly call wxTreeEvent::Allow(), as it's vetoed by default. Processes a `wxEVT_COMMAND_TREE_BEGIN_DRAG` event type.
- EVT_TREE_BEGIN_RDRAG(id, func):
  Begin dragging with the right mouse button. If you want to enable right-dragging you need to intercept this event and explicitly call wxTreeEvent::Allow(), as it's vetoed by default. Processes a `wxEVT_COMMAND_TREE_BEGIN_RDRAG` event type.
- EVT_TREE_END_DRAG(id, func):
  End dragging with the left or right mouse button. Processes a `wxEVT_COMMAND_TREE_END_DRAG` event type.
- EVT_TREE_BEGIN_LABEL_EDIT(id, func):
  Begin editing a label. This can be prevented by calling Veto(). Processes a `wxEVT_COMMAND_TREE_BEGIN_LABEL_EDIT` event type.
- EVT_TREE_END_LABEL_EDIT(id, func):
  Finish editing a label. This can be prevented by calling Veto(). Processes a `wxEVT_COMMAND_TREE_BEGIN_LABEL_EDIT` event type.
- EVT_TREE_DELETE_ITEM(id, func):
  An item was deleted. Processes a `wxEVT_COMMAND_TREE_DELETE_ITEM` event type.
- EVT_TREE_GET_INFO(id, func):
  Request information from the application. Processes a `wxEVT_COMMAND_TREE_GET_INFO` event type.
- EVT_TREE_SET_INFO(id, func):
  Information is being supplied. Processes a `wxEVT_COMMAND_TREE_SET_INFO` event type.
- EVT_TREE_ITEM_ACTIVATED(id, func):
  The item has been activated, i.e. chosen by double clicking it with mouse or from keyboard. Processes a `wxEVT_COMMAND_TREE_ITEM_ACTIVATED` event type.
- EVT_TREE_ITEM_COLLAPSED(id, func):
  The item has been collapsed. Processes a `wxEVT_COMMAND_TREE_ITEM_COLLAPSED` event type.
- EVT_TREE_ITEM_COLLAPSING(id, func):
  The item is being collapsed. This can be prevented by calling Veto(). Processes a `wxEVT_COMMAND_TREE_ITEM_COLLAPSING` event type.
- EVT_TREE_ITEM_EXPANDED(id, func):
  The item has been expanded. Processes a `wxEVT_COMMAND_TREE_ITEM_EXPANDED` event type.
- EVT_TREE_ITEM_EXPANDING(id, func):
  The item is being expanded. This can be prevented by calling Veto(). Processes a `wxEVT_COMMAND_TREE_ITEM_EXPANDING` event type.
- EVT_TREE_ITEM_RIGHT_CLICK(id, func):
  The user has clicked the item with the right mouse button. Processes a `wxEVT_COMMAND_TREE_ITEM_RIGHT_CLICK` event type.
- EVT_TREE_ITEM_MIDDLE_CLICK(id, func):
  The user has clicked the item with the middle mouse button. This is only supported by the generic control. Processes a `wxEVT_COMMAND_TREE_ITEM_MIDDLE_CLICK` event type.
- EVT_TREE_SEL_CHANGED(id, func):
  Selection has changed. Processes a `wxEVT_COMMAND_TREE_SEL_CHANGED` event type.
- EVT_TREE_SEL_CHANGING(id, func):
  Selection is changing. This can be prevented by calling Veto(). Processes a `wxEVT_COMMAND_TREE_SEL_CHANGING` event type.
- EVT_TREE_KEY_DOWN(id, func):
  A key has been pressed. Processes a `wxEVT_COMMAND_TREE_KEY_DOWN` event type.
- EVT_TREE_ITEM_GETTOOLTIP(id, func):
  The opportunity to set the item tooltip is being given to the application (call wxTreeEvent::SetToolTip). Windows only. Processes a `wxEVT_COMMAND_TREE_ITEM_GETTOOLTIP` event type.
- EVT_TREE_ITEM_MENU(id, func):
  The context menu for the selected item has been requested, either by a right click or by using the menu key. Processes a `wxEVT_COMMAND_TREE_ITEM_MENU` event type.
- EVT_TREE_STATE_IMAGE_CLICK(id, func):
  The state image has been clicked. Windows only. Processes a `wxEVT_COMMAND_TREE_STATE_IMAGE_CLICK` event type.

See also Window Styles.

Win32 notes:

wxTreeCtrl class uses the standard common treeview control under Win32 implemented in the system library comctl32.dll. Some versions of this library are known to have bugs with handling the tree control colours: the usual symptom is that the expanded items leave black (or otherwise incorrectly coloured) background behind them, especially for the controls using non-default background colour. The recommended solution is to upgrade the comctl32.dll to a newer version: see http://www.microsoft.com/downloads/details.aspx?familyid=cb2cf3a2-8025-4e8f-8511-9b476a8d35d2

##

Library: wxCore

Category: Controls
Appearance:

wxMSW appearance | wxGTK appearance | wxMac appearance

See also:
  wxDataViewTreeCtrl, wxTreeEvent, wxTreeItemData, wxTreeCtrl Overview, wxListBox, wxListCtrl, wxImageList

## Public Member Functions
| wxTreeCtrl ()
| Default Constructor.
| wxTreeCtrl (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxTR_DEFAULT_STYLE, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxTreeCtrlNameStr)
| Constructor, creating and showing a tree control.
virtual | ~wxTreeCtrl ()
| Destructor, destroying the tree control.
virtual wxTreeItemId | AddRoot (const wxString &text, int image=-1, int selImage=-1, wxTreeItemData *data=NULL)
| Adds the root node to the tree, returning the new item.
wxTreeItemId | AppendItem (const wxTreeItemId &parent, const wxString &text, int image=-1, int selImage=-1, wxTreeItemData *data=NULL)
| Appends an item to the end of the branch identified by parent, return a new item id.
void | AssignButtonsImageList (wxImageList *imageList)
| Sets the buttons image list.
void | AssignImageList (wxImageList *imageList)
| Sets the normal image list.
void | AssignStateImageList (wxImageList *imageList)
| Sets the state image list.
virtual void | Collapse (const wxTreeItemId &item)
| Collapses the given item.
void | CollapseAll ()
| Collapses the root item.
void | CollapseAllChildren (const wxTreeItemId &item)
| Collapses this item and all of its children, recursively.
virtual void | CollapseAndReset (const wxTreeItemId &item)
| Collapses the given item and removes all children.
bool | Create (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxTR_DEFAULT_STYLE, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxTreeCtrlNameStr)
| Creates the tree control.
virtual void | Delete (const wxTreeItemId &item)
| Deletes the specified item.
virtual void | DeleteAllItems ()
| Deletes all items in the control.
virtual void | DeleteChildren (const wxTreeItemId &item)
| Deletes all children of the given item (but not the item itself).
virtual wxTextCtrl * | EditLabel (const wxTreeItemId &item, wxClassInfo *textCtrlClass=wxCLASSINFO(wxTextCtrl))
| Starts editing the label of the given item.
virtual void | EndEditLabel (const wxTreeItemId &item, bool discardChanges=false)
| Ends label editing.
virtual void | EnsureVisible (const wxTreeItemId &item)
| Scrolls and/or expands items to ensure that the given item is visible.
virtual void | Expand (const wxTreeItemId &item)
| Expands the given item.
void | ExpandAll ()
| Expands all items in the tree.
void | ExpandAllChildren (const wxTreeItemId &item)
| Expands the given item and all its children recursively.
virtual bool | GetBoundingRect (const wxTreeItemId &item, wxRect &rect, bool textOnly=false) const
| Retrieves the rectangle bounding the item.
wxImageList * | GetButtonsImageList () const
| Returns the buttons image list (from which application-defined button images are taken).
virtual size_t | GetChildrenCount (const wxTreeItemId &item, bool recursively=true) const
| Returns the number of items in the branch.
virtual unsigned int | GetCount () const
| Returns the number of items in the control.
virtual wxTextCtrl * | GetEditControl () const
| Returns the edit control being currently used to edit a label.
virtual wxTreeItemId | GetFirstChild (const wxTreeItemId &item, wxTreeItemIdValue &cookie) const
| Returns the first child; call GetNextChild() for the next child.
virtual wxTreeItemId | GetFirstVisibleItem () const
| Returns the first visible item.
virtual wxTreeItemId | GetFocusedItem () const
| Returns the item last clicked or otherwise selected.
virtual void | ClearFocusedItem ()
| Clears the currently focused item.
virtual void | SetFocusedItem (const wxTreeItemId &item)
| Sets the currently focused item.
wxImageList * | GetImageList () const
| Returns the normal image list.
virtual unsigned int | GetIndent () const
| Returns the current tree control indentation.
virtual wxColour | GetItemBackgroundColour (const wxTreeItemId &item) const
| Returns the background colour of the item.
virtual wxTreeItemData * | GetItemData (const wxTreeItemId &item) const
| Returns the tree item data associated with the item.
virtual wxFont | GetItemFont (const wxTreeItemId &item) const
| Returns the font of the item label.
virtual int | GetItemImage (const wxTreeItemId &item, wxTreeItemIcon which=wxTreeItemIcon_Normal) const
| Gets the specified item image.
virtual wxTreeItemId | GetItemParent (const wxTreeItemId &item) const
| Returns the item's parent.
int | GetItemState (const wxTreeItemId &item) const
| Gets the specified item state.
virtual wxString | GetItemText (const wxTreeItemId &item) const
| Returns the item label.
virtual wxColour | GetItemTextColour (const wxTreeItemId &item) const
| Returns the colour of the item label.
virtual wxTreeItemId | GetLastChild (const wxTreeItemId &item) const
| Returns the last child of the item (or an invalid tree item if this item has no children).
virtual wxTreeItemId | GetNextChild (const wxTreeItemId &item, wxTreeItemIdValue &cookie) const
| Returns the next child; call GetFirstChild() for the first child.
virtual wxTreeItemId | GetNextSibling (const wxTreeItemId &item) const
| Returns the next sibling of the specified item; call GetPrevSibling() for the previous sibling.
virtual wxTreeItemId | GetNextVisible (const wxTreeItemId &item) const
| Returns the next visible item or an invalid item if this item is the last visible one.
virtual wxTreeItemId | GetPrevSibling (const wxTreeItemId &item) const
| Returns the previous sibling of the specified item; call GetNextSibling() for the next sibling.
virtual wxTreeItemId | GetPrevVisible (const wxTreeItemId &item) const
| Returns the previous visible item or an invalid item if this item is the first visible one.
bool | GetQuickBestSize () const
| Returns true if the control will use a quick calculation for the best size, looking only at the first and last items.
virtual wxTreeItemId | GetRootItem () const
| Returns the root item for the tree control.
virtual wxTreeItemId | GetSelection () const
| Returns the selection, or an invalid item if there is no selection.
virtual size_t | GetSelections (wxArrayTreeItemIds &selection) const
| Fills the array of tree items passed in with the currently selected items.
wxImageList * | GetStateImageList () const
| Returns the state image list (from which application-defined state images are taken).
wxTreeItemId | HitTest (const wxPoint &point, int &flags) const
| Calculates which (if any) item is under the given point, returning the tree item id at this point plus extra information flags.
wxTreeItemId | InsertItem (const wxTreeItemId &parent, const wxTreeItemId &previous, const wxString &text, int image=-1, int selImage=-1, wxTreeItemData *data=NULL)
| Inserts an item after a given one (previous).
wxTreeItemId | InsertItem (const wxTreeItemId &parent, size_t before, const wxString &text, int image=-1, int selImage=-1, wxTreeItemData *data=NULL)
| Inserts an item before one identified by its position (before).
virtual bool | IsBold (const wxTreeItemId &item) const
| Returns true if the given item is in bold state.
bool | IsEmpty () const
| Returns true if the control is empty (i.e.
virtual bool | IsExpanded (const wxTreeItemId &item) const
| Returns true if the item is expanded (only makes sense if it has children).
virtual bool | IsSelected (const wxTreeItemId &item) const
| Returns true if the item is selected.
virtual bool | IsVisible (const wxTreeItemId &item) const
| Returns true if the item is visible on the screen.
virtual bool | ItemHasChildren (const wxTreeItemId &item) const
| Returns true if the item has children.
virtual int | OnCompareItems (const wxTreeItemId &item1, const wxTreeItemId &item2)
| Override this function in the derived class to change the sort order of the items in the tree control.
wxTreeItemId | PrependItem (const wxTreeItemId &parent, const wxString &text, int image=-1, int selImage=-1, wxTreeItemData *data=NULL)
| Appends an item as the first child of parent, return a new item id.
virtual void | ScrollTo (const wxTreeItemId &item)
| Scrolls the specified item into view.
virtual void | SelectItem (const wxTreeItemId &item, bool select=true)
| Selects the given item.
void | SetButtonsImageList (wxImageList *imageList)
| Sets the buttons image list (from which application-defined button images are taken).
virtual void | SetImageList (wxImageList *imageList)
| Sets the normal image list.
virtual void | SetIndent (unsigned int indent)
| Sets the indentation for the tree control.
virtual void | SetItemBackgroundColour (const wxTreeItemId &item, const wxColour &col)
| Sets the colour of the item's background.
virtual void | SetItemBold (const wxTreeItemId &item, bool bold=true)
| Makes item appear in bold font if bold parameter is true or resets it to the normal state.
virtual void | SetItemData (const wxTreeItemId &item, wxTreeItemData *data)
| Sets the item client data.
virtual void | SetItemDropHighlight (const wxTreeItemId &item, bool highlight=true)
| Gives the item the visual feedback for Drag'n'Drop actions, which is useful if something is dragged from the outside onto the tree control (as opposed to a DnD operation within the tree control, which already is implemented internally).
virtual void | SetItemFont (const wxTreeItemId &item, const wxFont &font)
| Sets the item's font.
virtual void | SetItemHasChildren (const wxTreeItemId &item, bool hasChildren=true)
| Force appearance of the button next to the item.
virtual void | SetItemImage (const wxTreeItemId &item, int image, wxTreeItemIcon which=wxTreeItemIcon_Normal)
| Sets the specified item's image.
void | SetItemState (const wxTreeItemId &item, int state)
| Sets the specified item state.
virtual void | SetItemText (const wxTreeItemId &item, const wxString &text)
| Sets the item label.
virtual void | SetItemTextColour (const wxTreeItemId &item, const wxColour &col)
| Sets the colour of the item's text.
void | SetQuickBestSize (bool quickBestSize)
| If true is passed, specifies that the control will use a quick calculation for the best size, looking only at the first and last items.
virtual void | SetStateImageList (wxImageList *imageList)
| Sets the state image list (from which application-defined state images are taken).
void | SetWindowStyle (long styles)
| Sets the mode flags associated with the display of the tree control.
virtual void | SortChildren (const wxTreeItemId &item)
| Sorts the children of the given item using OnCompareItems().
virtual void | Toggle (const wxTreeItemId &item)
| Toggles the given item between collapsed and expanded states.
void | ToggleItemSelection (const wxTreeItemId &item)
| Toggles the given item between selected and unselected states.
virtual void | Unselect ()
| Removes the selection from the currently selected item (if any).
virtual void | UnselectAll ()
| This function either behaves the same as Unselect() if the control doesn't have `wxTR_MULTIPLE` style, or removes the selection from all items if it does have this style.
void | UnselectItem (const wxTreeItemId &item)
| Unselects the given item.
virtual void | SelectChildren (const wxTreeItemId &parent)
| Select all the immediate children of the given parent.

List of all members.

## Constructor & Destructor Documentation

wxTreeCtrl::wxTreeCtrl | ( |  | ) |

Default Constructor.

wxTreeCtrl::wxTreeCtrl | ( | wxWindow * | parent,
|  | wxWindowID | id = `wxID_ANY`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `wxTR_DEFAULT_STYLE`,
|  | const wxValidator & | validator = `wxDefaultValidator`,
|  | const wxString & | name = `wxTreeCtrlNameStr` |
| ) |  |  |

Constructor, creating and showing a tree control.

Parameters:

  | parent | Parent window. Must not be NULL.
  | id | Window identifier. The value `wxID_ANY` indicates a default value.
  | pos | Window position. If wxDefaultPosition is specified then a default position is chosen.
  | size | Window size. If wxDefaultSize is specified then the window is sized appropriately.
  | style | Window style. See wxTreeCtrl.
  | validator | Window validator.
  | name | Window name.

See also:
  Create(), wxValidator

virtual wxTreeCtrl::~wxTreeCtrl | ( |  | ) | `[virtual]`

Destructor, destroying the tree control.

## Member Function Documentation

virtual wxTreeItemId wxTreeCtrl::AddRoot | ( | const wxString & | text,
|  | int | image = `-1`,
|  | int | selImage = `-1`,
|  | wxTreeItemData * | data = `NULL` |
| ) |  |  | `[virtual]`

Adds the root node to the tree, returning the new item.

The image and selImage parameters are an index within the normal image list specifying the image to use for unselected and selected items, respectively. If image -1 and selImage is -1, the same image is used for both selected and unselected items.

wxTreeItemId wxTreeCtrl::AppendItem | ( | const wxTreeItemId & | parent,
|  | const wxString & | text,
|  | int | image = `-1`,
|  | int | selImage = `-1`,
|  | wxTreeItemData * | data = `NULL` |
| ) |  |  |

Appends an item to the end of the branch identified by parent, return a new item id.

The image and selImage parameters are an index within the normal image list specifying the image to use for unselected and selected items, respectively. If image -1 and selImage is -1, the same image is used for both selected and unselected items.

void wxTreeCtrl::AssignButtonsImageList | ( | wxImageList * | imageList | ) |

Sets the buttons image list.

The button images assigned with this method will be automatically deleted by wxTreeCtrl as appropriate (i.e. it takes ownership of the list).

Setting or assigning the button image list enables the display of image buttons. Once enabled, the only way to disable the display of button images is to set the button image list to NULL.

This function is only available in the generic version.

See also:
  SetButtonsImageList().

void wxTreeCtrl::AssignImageList | ( | wxImageList * | imageList | ) |

Sets the normal image list.

The image list assigned with this method will be automatically deleted by wxTreeCtrl as appropriate (i.e. it takes ownership of the list).

See also:
  SetImageList().

void wxTreeCtrl::AssignStateImageList | ( | wxImageList * | imageList | ) |

Sets the state image list.

Image list assigned with this method will be automatically deleted by wxTreeCtrl as appropriate (i.e. it takes ownership of the list).

See also:
  SetStateImageList().

virtual void wxTreeCtrl::ClearFocusedItem | ( |  | ) | `[virtual]`

Clears the currently focused item.

Since:
  2.9.1

virtual void wxTreeCtrl::Collapse | ( | const wxTreeItemId & | item | ) | `[virtual]`

Collapses the given item.

void wxTreeCtrl::CollapseAll | ( |  | ) |

Collapses the root item.

See also:
  ExpandAll()

void wxTreeCtrl::CollapseAllChildren | ( | const wxTreeItemId & | item | ) |

Collapses this item and all of its children, recursively.

See also:
  ExpandAllChildren()

virtual void wxTreeCtrl::CollapseAndReset | ( | const wxTreeItemId & | item | ) | `[virtual]`

Collapses the given item and removes all children.

bool wxTreeCtrl::Create | ( | wxWindow * | parent,
|  | wxWindowID | id = `wxID_ANY`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `wxTR_DEFAULT_STYLE`,
|  | const wxValidator & | validator = `wxDefaultValidator`,
|  | const wxString & | name = `wxTreeCtrlNameStr` |
| ) |  |  |

Creates the tree control.

See wxTreeCtrl::wxTreeCtrl() for further details.

virtual void wxTreeCtrl::Delete | ( | const wxTreeItemId & | item | ) | `[virtual]`

Deletes the specified item.

A `EVT_TREE_DELETE_ITEM` event will be generated.

This function may cause a subsequent call to GetNextChild() to fail.

virtual void wxTreeCtrl::DeleteAllItems | ( |  | ) | `[virtual]`

Deletes all items in the control.

Note that this may not generate `EVT_TREE_DELETE_ITEM` events under some Windows versions although normally such event is generated for each removed item.

virtual void wxTreeCtrl::DeleteChildren | ( | const wxTreeItemId & | item | ) | `[virtual]`

Deletes all children of the given item (but not the item itself).

Note that this will not generate any events unlike Delete() method.

If you have called SetItemHasChildren(), you may need to call it again since DeleteChildren() does not automatically clear the setting.

virtual wxTextCtrl* wxTreeCtrl::EditLabel | ( | const wxTreeItemId & | item,
|  | wxClassInfo * | textCtrlClass = `wxCLASSINFO(wxTextCtrl)` |
| ) |  |  | `[virtual]`

Starts editing the label of the given item.

This function generates a `EVT_TREE_BEGIN_LABEL_EDIT` event which can be vetoed so that no text control will appear for in-place editing.

If the user changed the label (i.e. s/he does not press ESC or leave the text control without changes, a `EVT_TREE_END_LABEL_EDIT` event will be sent which can be vetoed as well.

See also:
  EndEditLabel(), wxTreeEvent

virtual void wxTreeCtrl::EndEditLabel | ( | const wxTreeItemId & | item,
|  | bool | discardChanges = `false` |
| ) |  |  | `[virtual]`

Ends label editing.

If cancelEdit is true, the edit will be cancelled.

Note:
  This function is currently supported under Windows only.

See also:
  EditLabel()

virtual void wxTreeCtrl::EnsureVisible | ( | const wxTreeItemId & | item | ) | `[virtual]`

Scrolls and/or expands items to ensure that the given item is visible.

virtual void wxTreeCtrl::Expand | ( | const wxTreeItemId & | item | ) | `[virtual]`

Expands the given item.

void wxTreeCtrl::ExpandAll | ( |  | ) |

Expands all items in the tree.

void wxTreeCtrl::ExpandAllChildren | ( | const wxTreeItemId & | item | ) |

Expands the given item and all its children recursively.

virtual bool wxTreeCtrl::GetBoundingRect | ( | const wxTreeItemId & | item,
|  | wxRect & | rect,
|  | bool | textOnly = `false` |
| ) |  |  | const`[virtual]`

Retrieves the rectangle bounding the item.

If textOnly is true, only the rectangle around the item's label will be returned, otherwise the item's image is also taken into account.

The return value is true if the rectangle was successfully retrieved or `` false if it was not (in this case rect is not changed) -- for example, if the item is currently invisible.

Notice that the rectangle coordinates are logical, not physical ones. So, for example, the x coordinate may be negative if the tree has a horizontal scrollbar and its position is not 0.

wxPython Note: The wxPython version of this method requires only the item and textOnly parameters. The return value is either a wxRect object or `None`.

wxPerl Note: In wxPerl this method only takes the item and textOnly parameters and returns a `Wx::Rect` (or `undef`).

wxImageList* wxTreeCtrl::GetButtonsImageList | ( |  | ) | const

Returns the buttons image list (from which application-defined button images are taken).

This function is only available in the generic version.

virtual size_t wxTreeCtrl::GetChildrenCount | ( | const wxTreeItemId & | item,
|  | bool | recursively = `true` |
| ) |  |  | const`[virtual]`

Returns the number of items in the branch.

If recursively is true, returns the total number of descendants, otherwise only one level of children is counted.

virtual unsigned int wxTreeCtrl::GetCount | ( |  | ) | const`[virtual]`

Returns the number of items in the control.

virtual wxTextCtrl* wxTreeCtrl::GetEditControl | ( |  | ) | const`[virtual]`

Returns the edit control being currently used to edit a label.

Returns NULL if no label is being edited.

Note:
  This is currently only implemented for wxMSW.

virtual wxTreeItemId wxTreeCtrl::GetFirstChild | ( | const wxTreeItemId & | item,
|  | wxTreeItemIdValue & | cookie |
| ) |  |  | const`[virtual]`

Returns the first child; call GetNextChild() for the next child.

For this enumeration function you must pass in a 'cookie' parameter which is opaque for the application but is necessary for the library to make these functions reentrant (i.e. allow more than one enumeration on one and the same object simultaneously). The cookie passed to GetFirstChild() and GetNextChild() should be the same variable.

Returns an invalid tree item (i.e. wxTreeItemId::IsOk() returns false) if there are no further children.

wxPython Note: In wxPython the returned wxTreeItemId and the new cookie value are both returned as a tuple containing the two values.

wxPerl Note: In wxPerl this method only takes the item parameter, and returns a 2-element list (item, cookie).

See also:
  GetNextChild(), GetNextSibling()

virtual wxTreeItemId wxTreeCtrl::GetFirstVisibleItem | ( |  | ) | const`[virtual]`

Returns the first visible item.

virtual wxTreeItemId wxTreeCtrl::GetFocusedItem | ( |  | ) | const`[virtual]`

Returns the item last clicked or otherwise selected.

Unlike GetSelection(), it can be used whether or not the control has the `wxTR_MULTIPLE` style.

Since:
  2.9.1

wxImageList* wxTreeCtrl::GetImageList | ( |  | ) | const

Returns the normal image list.

virtual unsigned int wxTreeCtrl::GetIndent | ( |  | ) | const`[virtual]`

Returns the current tree control indentation.

virtual wxColour wxTreeCtrl::GetItemBackgroundColour | ( | const wxTreeItemId & | item | ) | const`[virtual]`

Returns the background colour of the item.

virtual wxTreeItemData* wxTreeCtrl::GetItemData | ( | const wxTreeItemId & | item | ) | const`[virtual]`

Returns the tree item data associated with the item.

See also:
  wxTreeItemData

wxPython Note: wxPython provides the following shortcut method:

- GetPyData(item): Returns the Python Object associated with the wxTreeItemData for the given item Id.

wxPerl Note: wxPerl provides the following shortcut method:

- GetPlData(item): returns the Perl data associated with the Wx::TreeItemData. It is just the same as tree->GetItemData(item)->GetData().

virtual wxFont wxTreeCtrl::GetItemFont | ( | const wxTreeItemId & | item | ) | const`[virtual]`

Returns the font of the item label.

virtual int wxTreeCtrl::GetItemImage | ( | const wxTreeItemId & | item,
|  | wxTreeItemIcon | which = `wxTreeItemIcon_Normal` |
| ) |  |  | const`[virtual]`

Gets the specified item image.

The value of which may be:

- wxTreeItemIcon_Normal: to get the normal item image.
- wxTreeItemIcon_Selected: to get the selected item image (i.e. the image which is shown when the item is currently selected).
- wxTreeItemIcon_Expanded: to get the expanded image (this only makes sense for items which have children - then this image is shown when the item is expanded and the normal image is shown when it is collapsed).
- wxTreeItemIcon_SelectedExpanded: to get the selected expanded image (which is shown when an expanded item is currently selected).

virtual wxTreeItemId wxTreeCtrl::GetItemParent | ( | const wxTreeItemId & | item | ) | const`[virtual]`

Returns the item's parent.

int wxTreeCtrl::GetItemState | ( | const wxTreeItemId & | item | ) | const

Gets the specified item state.

virtual wxString wxTreeCtrl::GetItemText | ( | const wxTreeItemId & | item | ) | const`[virtual]`

Returns the item label.

virtual wxColour wxTreeCtrl::GetItemTextColour | ( | const wxTreeItemId & | item | ) | const`[virtual]`

Returns the colour of the item label.

virtual wxTreeItemId wxTreeCtrl::GetLastChild | ( | const wxTreeItemId & | item | ) | const`[virtual]`

Returns the last child of the item (or an invalid tree item if this item has no children).

See also:
  GetFirstChild(), GetNextSibling(), GetLastChild()

virtual wxTreeItemId wxTreeCtrl::GetNextChild | ( | const wxTreeItemId & | item,
|  | wxTreeItemIdValue & | cookie |
| ) |  |  | const`[virtual]`

Returns the next child; call GetFirstChild() for the first child.

For this enumeration function you must pass in a 'cookie' parameter which is opaque for the application but is necessary for the library to make these functions reentrant (i.e. allow more than one enumeration on one and the same object simultaneously). The cookie passed to GetFirstChild() and GetNextChild() should be the same.

Returns an invalid tree item if there are no further children.

wxPython Note: In wxPython the returned wxTreeItemId and the new cookie value are both returned as a tuple containing the two values.

wxPerl Note: In wxPerl this method returns a 2-element list (item, cookie) instead of modifying its parameters.

See also:
  GetFirstChild()

virtual wxTreeItemId wxTreeCtrl::GetNextSibling | ( | const wxTreeItemId & | item | ) | const`[virtual]`

Returns the next sibling of the specified item; call GetPrevSibling() for the previous sibling.

Returns an invalid tree item if there are no further siblings.

See also:
  GetPrevSibling()

virtual wxTreeItemId wxTreeCtrl::GetNextVisible | ( | const wxTreeItemId & | item | ) | const`[virtual]`

Returns the next visible item or an invalid item if this item is the last visible one.

Note:
  The item itself must be visible.

virtual wxTreeItemId wxTreeCtrl::GetPrevSibling | ( | const wxTreeItemId & | item | ) | const`[virtual]`

Returns the previous sibling of the specified item; call GetNextSibling() for the next sibling.

Returns an invalid tree item if there are no further children.

See also:
  GetNextSibling()

virtual wxTreeItemId wxTreeCtrl::GetPrevVisible | ( | const wxTreeItemId & | item | ) | const`[virtual]`

Returns the previous visible item or an invalid item if this item is the first visible one.

Note:
  The item itself must be visible.

bool wxTreeCtrl::GetQuickBestSize | ( |  | ) | const

Returns true if the control will use a quick calculation for the best size, looking only at the first and last items.

The default is false.

See also:
  SetQuickBestSize()

virtual wxTreeItemId wxTreeCtrl::GetRootItem | ( |  | ) | const`[virtual]`

Returns the root item for the tree control.

virtual wxTreeItemId wxTreeCtrl::GetSelection | ( |  | ) | const`[virtual]`

Returns the selection, or an invalid item if there is no selection.

This function only works with the controls without `wxTR_MULTIPLE` style, use GetSelections() for the controls which do have this style or, if a single item is wanted, use GetFocusedItem().

virtual size_t wxTreeCtrl::GetSelections | ( | wxArrayTreeItemIds & | selection | ) | const`[virtual]`

Fills the array of tree items passed in with the currently selected items.

This function can be called only if the control has the `wxTR_MULTIPLE` style.

Returns the number of selected items.

wxPython Note: The wxPython version of this method accepts no parameters and returns a Python list of wxTreeItemIds.

wxPerl Note: In wxPerl this method takes no parameters and returns a list of `Wx::TreeItemId`.

wxImageList* wxTreeCtrl::GetStateImageList | ( |  | ) | const

Returns the state image list (from which application-defined state images are taken).

wxTreeItemId wxTreeCtrl::HitTest | ( | const wxPoint & | point,
|  | int & | flags |
| ) |  |  | const

Calculates which (if any) item is under the given point, returning the tree item id at this point plus extra information flags.

flags is a bitlist of the following:

- `wxTREE_HITTEST_ABOVE:` Above the client area.
- `wxTREE_HITTEST_BELOW:` Below the client area.
- `wxTREE_HITTEST_NOWHERE:` In the client area but below the last item.
- `wxTREE_HITTEST_ONITEMBUTTON:` On the button associated with an item.
- `wxTREE_HITTEST_ONITEMICON:` On the bitmap associated with an item.
- `wxTREE_HITTEST_ONITEMINDENT:` In the indentation associated with an item.
- `wxTREE_HITTEST_ONITEMLABEL:` On the label (string) associated with an item.
- `wxTREE_HITTEST_ONITEMRIGHT:` In the area to the right of an item.
- `wxTREE_HITTEST_ONITEMSTATEICON:` On the state icon for a tree view item that is in a user-defined state.
- `wxTREE_HITTEST_TOLEFT:` To the right of the client area.
- `wxTREE_HITTEST_TORIGHT:` To the left of the client area.

wxPython Note: In wxPython both the wxTreeItemId and the flags are returned as a tuple.

wxPerl Note: In wxPerl this method only takes the point parameter and returns a 2-element list (item, flags).

wxTreeItemId wxTreeCtrl::InsertItem | ( | const wxTreeItemId & | parent,
|  | size_t | before,
|  | const wxString & | text,
|  | int | image = `-1`,
|  | int | selImage = `-1`,
|  | wxTreeItemData * | data = `NULL` |
| ) |  |  |

Inserts an item before one identified by its position (before).

before must be less than the number of children.

The image and selImage parameters are an index within the normal image list specifying the image to use for unselected and selected items, respectively. If image -1 and selImage is -1, the same image is used for both selected and unselected items.

wxPython Note: In wxPython, this form of this method is called `InsertItemBefore()`.

wxTreeItemId wxTreeCtrl::InsertItem | ( | const wxTreeItemId & | parent,
|  | const wxTreeItemId & | previous,
|  | const wxString & | text,
|  | int | image = `-1`,
|  | int | selImage = `-1`,
|  | wxTreeItemData * | data = `NULL` |
| ) |  |  |

Inserts an item after a given one (previous).

The image and selImage parameters are an index within the normal image list specifying the image to use for unselected and selected items, respectively. If image -1 and selImage is -1, the same image is used for both selected and unselected items.

virtual bool wxTreeCtrl::IsBold | ( | const wxTreeItemId & | item | ) | const`[virtual]`

Returns true if the given item is in bold state.

See also:
  SetItemBold()

bool wxTreeCtrl::IsEmpty | ( |  | ) | const

Returns true if the control is empty (i.e.

has no items, even no root one).

virtual bool wxTreeCtrl::IsExpanded | ( | const wxTreeItemId & | item | ) | const`[virtual]`

Returns true if the item is expanded (only makes sense if it has children).

virtual bool wxTreeCtrl::IsSelected | ( | const wxTreeItemId & | item | ) | const`[virtual]`

Returns true if the item is selected.

virtual bool wxTreeCtrl::IsVisible | ( | const wxTreeItemId & | item | ) | const`[virtual]`

Returns true if the item is visible on the screen.

virtual bool wxTreeCtrl::ItemHasChildren | ( | const wxTreeItemId & | item | ) | const`[virtual]`

Returns true if the item has children.

virtual int wxTreeCtrl::OnCompareItems | ( | const wxTreeItemId & | item1,
|  | const wxTreeItemId & | item2 |
| ) |  |  | `[virtual]`

Override this function in the derived class to change the sort order of the items in the tree control.

The function should return a negative, zero or positive value if the first item is less than, equal to or greater than the second one.

Please note that you must use wxRTTI macros wxDECLARE_DYNAMIC_CLASS() and wxIMPLEMENT_DYNAMIC_CLASS() if you override this function because otherwise the base class considers that it is not overridden and uses the default comparison, i.e. sorts the items alphabetically, which allows it optimize away the calls to the virtual function completely.

See also:
  SortChildren()

wxTreeItemId wxTreeCtrl::PrependItem | ( | const wxTreeItemId & | parent,
|  | const wxString & | text,
|  | int | image = `-1`,
|  | int | selImage = `-1`,
|  | wxTreeItemData * | data = `NULL` |
| ) |  |  |

Appends an item as the first child of parent, return a new item id.

The image and selImage parameters are an index within the normal image list specifying the image to use for unselected and selected items, respectively. If image -1 and selImage is -1, the same image is used for both selected and unselected items.

virtual void wxTreeCtrl::ScrollTo | ( | const wxTreeItemId & | item | ) | `[virtual]`

Scrolls the specified item into view.

virtual void wxTreeCtrl::SelectChildren | ( | const wxTreeItemId & | parent | ) | `[virtual]`

Select all the immediate children of the given parent.

This function can be used with multiselection controls only.

Since:
  2.9.1

virtual void wxTreeCtrl::SelectItem | ( | const wxTreeItemId & | item,
|  | bool | select = `true` |
| ) |  |  | `[virtual]`

Selects the given item.

In multiple selection controls, can be also used to deselect a currently selected item if the value of select is false.

Notice that calling this method will generate `wxEVT_COMMAND_TREE_SEL_CHANGING` and `wxEVT_COMMAND_TREE_SEL_CHANGED` events and that the change could be vetoed by the former event handler.

void wxTreeCtrl::SetButtonsImageList | ( | wxImageList * | imageList | ) |

Sets the buttons image list (from which application-defined button images are taken).

The button images assigned with this method will not be deleted by wxTreeCtrl's destructor, you must delete it yourself. Setting or assigning the button image list enables the display of image buttons. Once enabled, the only way to disable the display of button images is to set the button image list to NULL.

Note:
  This function is only available in the generic version.

See also:
  AssignButtonsImageList().

virtual void wxTreeCtrl::SetFocusedItem | ( | const wxTreeItemId & | item | ) | `[virtual]`

Sets the currently focused item.

Parameters:

  | item | The item to make the current one. It must be valid.

Since:
  2.9.1

virtual void wxTreeCtrl::SetImageList | ( | wxImageList * | imageList | ) | `[virtual]`

Sets the normal image list.

The image list assigned with this method will not be deleted by wxTreeCtrl's destructor, you must delete it yourself.

See also:
  AssignImageList().

virtual void wxTreeCtrl::SetIndent | ( | unsigned int | indent | ) | `[virtual]`

Sets the indentation for the tree control.

virtual void wxTreeCtrl::SetItemBackgroundColour | ( | const wxTreeItemId & | item,
|  | const wxColour & | col |
| ) |  |  | `[virtual]`

Sets the colour of the item's background.

virtual void wxTreeCtrl::SetItemBold | ( | const wxTreeItemId & | item,
|  | bool | bold = `true` |
| ) |  |  | `[virtual]`

Makes item appear in bold font if bold parameter is true or resets it to the normal state.

See also:
  IsBold()

virtual void wxTreeCtrl::SetItemData | ( | const wxTreeItemId & | item,
|  | wxTreeItemData * | data |
| ) |  |  | `[virtual]`

Sets the item client data.

Notice that the client data previously associated with the item (if any) is not freed by this function and so calling this function multiple times for the same item will result in memory leaks unless you delete the old item data pointer yourself.

wxPython Note:

- SetPyData( item, `obj`): Associate the given Python Object with the wxTreeItemData for the given item Id.

wxPerl Note: wxPerl provides the following shortcut method:

- SetPlData(item, data): sets the Perl data associated with the `Wx::TreeItemData`. It is just the same as tree->GetItemData(item)->SetData(data).

virtual void wxTreeCtrl::SetItemDropHighlight | ( | const wxTreeItemId & | item,
|  | bool | highlight = `true` |
| ) |  |  | `[virtual]`

Gives the item the visual feedback for Drag'n'Drop actions, which is useful if something is dragged from the outside onto the tree control (as opposed to a DnD operation within the tree control, which already is implemented internally).

virtual void wxTreeCtrl::SetItemFont | ( | const wxTreeItemId & | item,
|  | const wxFont & | font |
| ) |  |  | `[virtual]`

Sets the item's font.

All items in the tree should have the same height to avoid text clipping, so the fonts height should be the same for all of them, although font attributes may vary.

See also:
  SetItemBold()

virtual void wxTreeCtrl::SetItemHasChildren | ( | const wxTreeItemId & | item,
|  | bool | hasChildren = `true` |
| ) |  |  | `[virtual]`

Force appearance of the button next to the item.

This is useful to allow the user to expand the items which don't have any children now, but instead adding them only when needed, thus minimizing memory usage and loading time.

virtual void wxTreeCtrl::SetItemImage | ( | const wxTreeItemId & | item,
|  | int | image,
|  | wxTreeItemIcon | which = `wxTreeItemIcon_Normal` |
| ) |  |  | `[virtual]`

Sets the specified item's image.

See GetItemImage() for the description of the which parameter.

void wxTreeCtrl::SetItemState | ( | const wxTreeItemId & | item,
|  | int | state |
| ) |  |  |

Sets the specified item state.

The value of state may be:

- `wxTREE_ITEMSTATE_NONE:` to disable the item state (the state image will be not displayed).
- `wxTREE_ITEMSTATE_NEXT:` to set the next item state.
- `wxTREE_ITEMSTATE_PREV:` to set the previous item state.

virtual void wxTreeCtrl::SetItemText | ( | const wxTreeItemId & | item,
|  | const wxString & | text |
| ) |  |  | `[virtual]`

Sets the item label.

virtual void wxTreeCtrl::SetItemTextColour | ( | const wxTreeItemId & | item,
|  | const wxColour & | col |
| ) |  |  | `[virtual]`

Sets the colour of the item's text.

void wxTreeCtrl::SetQuickBestSize | ( | bool | quickBestSize | ) |

If true is passed, specifies that the control will use a quick calculation for the best size, looking only at the first and last items.

Otherwise, it will look at all items. The default is false.

See also:
  GetQuickBestSize()

virtual void wxTreeCtrl::SetStateImageList | ( | wxImageList * | imageList | ) | `[virtual]`

Sets the state image list (from which application-defined state images are taken).

Image list assigned with this method will not be deleted by wxTreeCtrl's destructor, you must delete it yourself.

See also:
  AssignStateImageList().

void wxTreeCtrl::SetWindowStyle | ( | long | styles | ) |

Sets the mode flags associated with the display of the tree control.

The new mode takes effect immediately.

Note:
  Generic only; MSW ignores changes.

Reimplemented from wxWindow.

virtual void wxTreeCtrl::SortChildren | ( | const wxTreeItemId & | item | ) | `[virtual]`

Sorts the children of the given item using OnCompareItems().

You should override that method to change the sort order (the default is ascending case-sensitive alphabetical order).

See also:
  wxTreeItemData, OnCompareItems()

virtual void wxTreeCtrl::Toggle | ( | const wxTreeItemId & | item | ) | `[virtual]`

Toggles the given item between collapsed and expanded states.

void wxTreeCtrl::ToggleItemSelection | ( | const wxTreeItemId & | item | ) |

Toggles the given item between selected and unselected states.

For multiselection controls only.

virtual void wxTreeCtrl::Unselect | ( |  | ) | `[virtual]`

Removes the selection from the currently selected item (if any).

virtual void wxTreeCtrl::UnselectAll | ( |  | ) | `[virtual]`

This function either behaves the same as Unselect() if the control doesn't have `wxTR_MULTIPLE` style, or removes the selection from all items if it does have this style.

void wxTreeCtrl::UnselectItem | ( | const wxTreeItemId & | item | ) |

Unselects the given item.

This works in multiselection controls only.

|  | [ top ]